// This file exists both in mobile and webclient. Please make sure to keep them in sync if changes are made.

(function() 
{
    var cordovaRef = window.PhoneGap || window.Cordova || window.cordova;
 
    if( window.nexj == undefined)
    {
        window.nexj = { };
    }

    if( nexj.pg == undefined)
    {
        nexj.pg = { };
    }

    nexj.pg.LocalNotification = function ()
    {
        this.callBack = null;
    };

    nexj.pg.LocalNotification.prototype.onMessageReceived = function (messageBody)
    {
        if(this.callBack != null )
        {
            this.callBack(messageBody);
        }
    };

    nexj.pg.LocalNotification.prototype.registerNotification = function (timeToStart, messageTitle, messageBody, payload, successCallback, failureCallback)
    {
        return cordovaRef.exec(successCallback,
            failureCallback,
            'LocalNotificationPlugin',
            'registerNotification',
            [this.formatDate(new Date(timeToStart)), messageTitle, messageBody, payload]
         ); 
    };
    
    nexj.pg.LocalNotification.prototype.cancelAllNotifications = function (successCallback, failureCallback)
    {
        return cordovaRef.exec(successCallback,
            failureCallback,
            'LocalNotificationPlugin',
            'cancelAll',
            []
         );
    };

    nexj.pg.LocalNotification.prototype.getNotification = function (successCallback, failureCallback)
    {
        return cordovaRef.exec(successCallback,    
                             failureCallback,    
                             'LocalNotificationPlugin', 
                             'getNotification',    
                             []);       
    };

    nexj.pg.LocalNotification.prototype.getPendingFiredNotifications = function (successCallback, failureCallback)
    {
        return cordovaRef.exec(successCallback,   
                             failureCallback,   
                             'LocalNotificationPlugin',
                             'getPendingFiredNotifications',   
                             []);      
    };
   
    nexj.pg.LocalNotification.prototype.addPendingFiredNotification = function (payload, successCallback, failureCallback)
    {
        return cordovaRef.exec(successCallback,   
                             failureCallback,   
                             'LocalNotificationPlugin',
                             'addPendingFiredNotification',   
                             [payload]);
    };
   
    nexj.pg.LocalNotification.prototype.clearPendingFiredNotifications = function (successCallback, failureCallback)
    {
        return cordovaRef.exec(successCallback,   
                             failureCallback,   
                             'LocalNotificationPlugin',
                             'clearPendingFiredNotifications',   
                             []);      
    };

    nexj.pg.LocalNotification.prototype.formatDate = function (timeToStart)
    {
        var result = "";

        var date = timeToStart.getDate().toString();
        var month = (timeToStart.getMonth() + 1).toString();
        var fullYear = timeToStart.getFullYear().toString();
        var hours = timeToStart.getHours().toString();
        var minutes = timeToStart.getMinutes().toString();
        var seconds = timeToStart.getSeconds().toString();

        if( date.length == 1 )
        {
            date = "0" + date;
        }

        if( month.length == 1 )
        {
            month = "0" + month;
        }

        if( hours.length == 1 )
        {
            hours = "0" + hours;
        }

        if( minutes.length == 1 )
        {
            minutes = "0" + minutes;
        }

        if (seconds.length == 1)
        {
            seconds = "0" + seconds;
        }

        // "yyyy/MM/dd HH:mm:ss"
        return fullYear + "/" + month + "/" + date + " " + hours + ":" + minutes + ":" + seconds;
    };

    nexj.pg.Authentication = function ()
    {

    };

    nexj.pg.Authentication.prototype.setCredentials = function (login, password, successCallback, failureCallback)
    {
        return cordovaRef.exec(successCallback,
                             failureCallback,
                             'AuthenticationPlugin',
                             'set',
                             [login, password]
                            );      
    };

    nexj.pg.Authentication.prototype.removeCredentials = function (successCallback, failureCallback)
    {
        return cordovaRef.exec(successCallback,
                             failureCallback,
                             'AuthenticationPlugin', 
                             'remove',    
                             []);       
    };

    nexj.pg.Authentication.prototype.getError = function (successCallback, failureCallback)
    {
        return cordovaRef.exec(successCallback,    
                             failureCallback,    
                             'AuthenticationPlugin', 
                             'getError',    
                             []);       
    };

    nexj.pg.Authentication.prototype.setError = function (errorCode, errorDescription, failingUrl, successCallback, failureCallback)
    {
        return cordovaRef.exec(successCallback,    
                             failureCallback,    
                             'AuthenticationPlugin', 
                             'setError',    
                             [errorCode, errorDescription, failingUrl]);       
    };

    nexj.pg.Authentication.prototype.getGuid = function (successCallback, failureCallback)
    {
        return cordovaRef.exec(successCallback,    
                             failureCallback,    
                             'AuthenticationPlugin', 
                             'getGUID',    
                             []);       
    };

    nexj.pg.Navigation = function ()
    {

    };

    nexj.pg.Navigation.prototype.redirectToHomePage = function (successCallback, failureCallback)
    {
        return cordovaRef.exec(successCallback,    
                             failureCallback,    
                             'NavigationPlugin', 
                             'redirectToHomePage',    
                             []);       
    };

    nexj.pg.Navigation.prototype.redirectToUrl = function (url, successCallback, failureCallback)
    {
        return cordovaRef.exec(successCallback,    
                             failureCallback,    
                             'NavigationPlugin', 
                             'redirectToUrl',    
                             [url]);       
    };
 
    nexj.pg.Portal = function()
    {
    };
 
    nexj.pg.Portal.prototype.loadConfig = function(config, successCallback, failureCallback)
    {
        return cordovaRef.exec(successCallback,
                        failureCallback,
                        'PortalPlugin',
                        'loadConfig',
                        [config]);
    };
 
    nexj.pg.Portal.prototype.loadManager = function(successCallback, failureCallback)
    {
        return cordovaRef.exec(successCallback,
                               failureCallback,
                               'PortalPlugin',
                               'loadManager',
                               []);
    };
 
    nexj.pg.Portal.prototype.invokeAPI = function(sSelector, args, successCallback, failureCallback)
    {
        //window.plugins.portalViewId is set by native code on page load
        return cordovaRef.exec(successCallback,
                        failureCallback,
                        'PortalPlugin',
                        'invokeAPI',
                        [window.plugins.portalViewId, sSelector, args]);
    };
 
    nexj.pg.Portal.prototype.execJS = function(sTargetViewId, jsCode, successCallback, failureCallback)
    {
        return cordovaRef.exec(successCallback,
                        failureCallback,
                        'PortalPlugin',
                        'execJS',
                        [window.plugins.portalViewId, sTargetViewId, jsCode]);
    }
 
    nexj.pg.Portal.prototype.createLayoutView = function(sParentViewId, viewOptions, successCallback, failureCallback)
    {
        return cordovaRef.exec(successCallback,
                        failureCallback,
                        'PortalPlugin',
                        'createLayoutView',
                        [window.plugins.portalViewId, sParentViewId, viewOptions]);
    }
 
    nexj.pg.Portal.prototype.setDefaultWorkspace = function(successCallback, failureCallback)
    {
        return cordovaRef.exec(successCallback,
                        failureCallback,
                        'PortalPlugin',
                        'setDefaultWorkspace',
                        [window.plugins.portalViewId]);
    }
 
    cordovaRef.addConstructor(function ()
    {
        if (!window.plugins)
        {
            window.plugins = {};
        }
        window.plugins.localNotification = new nexj.pg.LocalNotification();
        window.plugins.authentication = new nexj.pg.Authentication();
        window.plugins.navigation = new nexj.pg.Navigation();
        window.plugins.portal = new nexj.pg.Portal();
    });
 })();